           .386
           .model     flat, stdcall
           option     casemap :none   ; case sensitive
           .nolist
           include    D:\masm32\include\windows.inc
           include    D:\masm32\include\user32.inc
           include    D:\masm32\include\kernel32.inc
           include    D:\masm32\include\gdi32.inc
           include    D:\masm32\include\winmm.inc
           includelib D:\masm32\lib\user32.lib
           includelib D:\masm32\lib\kernel32.lib
           includelib D:\masm32\lib\gdi32.lib
           includelib D:\masm32\lib\winmm.lib
           .list

;******** Datenbereich

; bei den Datenbereichen gibt es zwei Arten. Dieser hier ist fix im Programm, hier knnen
; auch Werte definiert sein
           .data
EinByte    db    0
EinWort    DW    0
Doppelwort DD    0
QuadWort   DQ    0

; Dieser Datenbereich kann nur im Ablauf gendert werden. Er wird erst beim Programmaufruf
; zugeordnet! Hier knnen keine Werte in der Source angegeben werden.
; Dieser Datenbereich mu nicht vorhanden sein.
           .data?
Nochwas    db    ?

; Dieser Konstantenbereich kann nicht im Ablauf gendert werden.
; Dieser Bereich mu nicht vorhanden sein.
           .const
; damit werden Informationen ber die DLL angezeigt (Prozedur Dll_Info)
CopyRight  db  "DLL1.DLL.",13,10,"Version 3.0, vom 30.August 2003   "
           db  "Autor gerhard-putschalka@gmx.at",13,10,10
           db  "Fr Schden durch eine Fehlfunktion "
           db  "der DLL kann keine",13,10,"Haftung bernommen werden.",0
CopyRig02  db  "Info",0

;******** Codebereich
           .code
LibMain   proc hInstDLL:DWORD, reason:DWORD, unused:DWORD
                            ;Start-Einsprungspunkt der DLL
          mov  eax,1
          ret

LibMain   Endp

; include Support.inc    ; zu Testzwecken fr DspReg, DspString, DspHString

;---------------------------------------------------------------
; addiert oder subtrahiert 2 DWords (LongInteger) abhngig von Parm3 (1=add, sonst sub)
;##### Funktion: addieren oder subtrahieren.  Es werden 3 Parameter erwartet ######
addieren  proc  Wert1, Wert2, OpCod:DWord
          mov   eax,Wert1 
          .if   OpCod==1
            add   eax,Wert2
          .else
            sub   eax,Wert2
          .endif
; Der Wert in eax ist beim Beenden der Funktion immer das Ergebnis fr Profan
; hier ist es das Ergebnis der Addition
           ret
addieren  endp

;---------------------------------------------------------------
; subtrahiert Floatwert2 von Floatwert1. Es wird der Matheprozessor benutzt.
; beide Floatwerte als DWords (4-Byte)
;##### Funktion: SubReal4.  Es werden 2 Parameter erwartet ######
SubReal4  proc   Wert1, Wert2:DWord
          LOCAL  IntVar:DWord
          fninit
          fld    dword ptr Wert1
          fld    dword ptr Wert2
          fsub
          fstp   IntVar                       ; Ergebnis zwischenspeichern
          mov    eax,IntVar           
          ret

SubReal4  endp

;---------------------------------------------------------------
; Multipliziert 2 Floatwerte. Es wird der Matheprozessor benutzt.
; beide Floatwerte als QWords (8-Byte). Ergebnis wird in Parameter3 gestellt
; ACHTUNG: hier werden die Adressen der Variablen bernommen!
;##### Funktion: MulReal8.  Es werden 3 Parameter erwartet ######
MulReal8  proc  Wert1, Wert2, Ergebnis:DWord

          mov     eax,Wert1         ; Adresse Variable 1
          mov     edx,Wert2         ; Adresse Variable 2
          fninit
          fld     qword ptr [eax]
          fld     qword ptr [edx]
          fmul
          mov     edi,Ergebnis      ; Adresse Variable 3
          fstp    qword ptr [edi]   ; Ergebnis direkt in Variable 3 stellen   

          mov     eax, 1   ; irgendein Wert, = Returnwert zu Profan
          ret 
MulReal8  endp

;---------------------------------------------------------------
; Zeichenfolge umkehren
;###### Funktion: umdrehen   Es wird 1 Parameter erwartet ######
umdrehen  proc  DatenAdr:DWord 
          mov   esi,DatenAdr   ; Adresse 1 Stelle im String
          invoke lstrlen, DatenAdr ; ermittle Stringlnge
          mov   edi,esi
          add   edi,eax
          dec   edi            ; Adresse letzte Stelle im String
          shr   eax,1          ; divid. Lnge/2  ohne Rundung
          mov   ecx,eax        ; Anzahl Durchlufe
          .while ecx>0
            ; tausche Bytes in [esi] <--> [edi]
            mov  al,byte ptr [esi]
            mov  ah,byte ptr [edi]
            mov  byte ptr [esi],ah
            mov  byte ptr [edi],al
            inc  esi
            dec  edi
            dec  ecx
          .endw

          mov   eax,DatenAdr       ; Rckparameter an Profan bergeben (eax)
          ret  
umdrehen  endp

;---------------------------------------------------------------
;##### Funktion: concat.  Es werden 3 Parameter erwartet ######
concat  proc  Adress1, Adress2, Adress3:DWord

          invoke lstrcpy, Adress3, Adress1
          invoke lstrcat, Adress3, Adress2

; Der Wert in eax ist die Lnge des Ergebnisstrings und damit das Ergebnis fr Profan
          ret
concat  endp

;---------------------------------------------------------------
Dll_Info  proc    ;##############################################################
          invoke  MessageBoxA, 0,addr CopyRight,addr CopyRig02,MB_OK
          ret
Dll_Info  endp

End       LibMain
