;*******************************************************************
; zeige die Inhalte der Daten- und Indexregister in einer Messagebox an.
; Aufruf:           invoke  DspRegA
;*******************************************************************
DspAeg  PROTO:DWORD,:DWORD
DspAeg  Proc  Adres:dword,Reg:dword
        push   edi
	mov    edi,Adres
	cld
	push   eax
	mov    eax,Reg
	mov    dword ptr [edi],eax
	mov    word ptr [edi+4]," ="
	mov    byte ptr [edi+14],0Ah
	add    edi,12
	pop    eax
	push   ecx
	mov    ecx,4
DspA02: push   eax	
	mov    ah,al
	shr    al,4
	and    ax,0F0Fh
	.if    al>9h
	  add  al,7
	.endif       
	.if    ah>9h
	  add  ah,7
	.endif       
	add    ax,3030h
	mov    word ptr [edi],ax
	sub    edi,2
	pop    eax
	shr    eax,8
	loop   DspA02
	pop    ecx
	pop    edi
	ret
DspAeg  endp


DspReg  Proc  ;  zeige Inhalt der Daten- und Indexregister. Keine Parameter
        LOCAL Work80[100]:BYTE, WrkAdr:dword
        pushfd
        pusha
	push	eax
	lea	eax,Work80
	mov	WrkAdr,eax
	pop	eax
	invoke  DspAeg, WrkAdr," XAE"
        add     WrkAdr,15
	mov	eax,ebx
	invoke  DspAeg, WrkAdr," XBE"
        add     WrkAdr,15
	mov	eax,ecx
	invoke  DspAeg, WrkAdr," XCE"
        add     WrkAdr,15
	mov	eax,edx
	invoke  DspAeg, WrkAdr," XDE"
        add     WrkAdr,15
	mov	eax,edi
	invoke  DspAeg, WrkAdr," IDE"
        add     WrkAdr,15
	mov	eax,esi
	invoke  DspAeg, WrkAdr," ISE"
	mov     Work80+90,0
        lea     eax,@RegTit
        invoke MessageBox, 0, addr Work80, eax, MB_OKCANCEL
        .if eax==IDCANCEL	
           invoke  ExitProcess, 0
        .endif
        popa
        popfd
        ret
        .data
@RegTit db  "Registeranzeige",0
       .code
DspReg  endp
;*******************************************************************
; zeige String in einer Messagebox an.
; Aufruf: invoke  DspString, addr Message-String, addr Titeltext
; Fr Parameter 2 kann auch 0 angegeben werden (Standard Text als Titel)
; Die Strings mssen mit 0h abgeschlossen sein!
;*******************************************************************
DspString proc   text1:dword,titel:dword
          pusha
          pushfd
          mov   eax,titel          
          .if   eax==0
             lea eax,@Dspstr
          .endif
          invoke MessageBoxA, 0,text1,eax,MB_OKCANCEL
          .if eax==IDCANCEL	
             invoke  ExitProcess, 0
          .endif
          popfd
          popa
          ret
 .data
@Dspstr   db  "Stringanzeige ",0
 .code
DspString endp
;*******************************************************************
; zeige Hex-String in einer Messagebox an.
; Aufruf: invoke  DspHString, addr String, Nbr, addr BoxTitel
; es werden maximal 50 Bytes des Strings angezeigt
;
; Nur der String fr Parameter 3 mu mit 0h abgeschlossen sein!
; Fr Parameter 3 kann auch 0 angegeben werden (Standard Text als Titel)
;*******************************************************************
DspHString proc   text1:dword, Nbr:DWord, titel:dword
          LOCAL  TiTxt[30]:Byte,HString[101]:Byte,X:DWord
          pusha
          pushfd

          mov    ecx,Nbr
          .if    ecx>50
             mov ecx,50
          .endif
          cld
          mov    esi,text1
          lea    edi,HString
          mov    X,4
          .while ecx>0
             lodsb
             mov ah,al 
             and ax,0FF0h
             shr al,4
             or  ax,3030h
             .if ah>39h
                add ah,7
             .endif
             .if al>39h
                add al,7
             .endif
             stosw
             dec    X
             .if    X==0
                mov X,4
                mov al,20h
                stosb
             .endif
             dec    ecx
          .endw
          mov    byte ptr [edi],0
          mov eax,titel 
         .if   eax==0
             lea eax,@DspHstr
          .endif
          invoke MessageBoxA, 0,addr HString,eax,MB_OKCANCEL	
          .if eax==IDCANCEL	
             invoke  ExitProcess, 0
          .endif
          popfd
          popa
          ret
 .data
@DspHstr  db  "Hex-Stringanzeige ",0
 .code
DspHString endp
;*******************************************************************